---
title: WebGL2RenderingContext.invalidateSubFramebuffer()
slug: Web/API/WebGL2RenderingContext/invalidateSubFramebuffer
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGL2
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGL2RenderingContext.invalidateSubFramebuffer()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL 2 API</a> invalidates portions of the contents of attachments in a framebuffer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.invalidateSubFramebuffer(<var>target</var>, <var>attachments</var>, <var>x</var>, <var>y</var>, <var>width</var>, <var>height</var>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>target</code></dt>
 <dd>A {{domxref("GLenum")}} specifying the binding point (target). Possible values:
 <ul>
  <li><code>gl.FRAMEBUFFER</code>: Collection buffer data storage of color, alpha, depth and stencil buffers used to render an image.</li>
  <li><code>gl.DRAW_FRAMEBUFFER</code>: Equivalent to <code>gl.FRAMEBUFFER</code>.</li>
  <li><code>gl.READ_FRAMEBUFFER</code>: Used as a source for reading operations.</li>
 </ul>
 </dd>
 <dt><code>attachments</code></dt>
 <dd>An {{jsxref("Array")}} of {{domxref("GLenum")}} specifying the attachment points to invalidate. Possible values:
 <ul>
  <li><code>gl.COLOR_ATTACHMENT{0-15}</code>: Invalidates one of the framebuffer's color buffers.</li>
  <li><code>gl.DEPTH_ATTACHMENT</code>: Invalidates the framebuffer's depth buffer.</li>
  <li><code>gl.STENCIL_ATTACHMENT</code>: Invalidates the framebuffer's stencil buffer.</li>
  <li><code>gl.DEPTH_STENCIL_ATTACHMENT</code>: Invalidates both the framebuffer's depth and stencil buffer.</li>
 </ul>
 </dd>
 <dt><code>x</code></dt>
 <dd>A {{domxref("GLint")}} specifying the left origin of the pixel rectangle to invalidate.</dd>
 <dt><code>y</code></dt>
 <dd>A {{domxref("GLint")}} specifying the bottom origin of the pixel rectangle to invalidate.</dd>
 <dt><code>width</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the width of the pixel rectangle to invalidate.</dd>
 <dt><code>height</code></dt>
 <dd>A {{domxref("GLsizei")}} specifying the height of the pixel rectangle to invalidate.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<pre class="brush: js">gl.invalidateSubFramebuffer(gl.READ_FRAMEBUFFER,
                            [gl.COLOR_ATTACHMENT0, gl.COLOR_ATTACHMENT1],
                            0, 0, 256, 256);
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL2', "#3.7.4", "invalidateSubFramebuffer")}}</td>
   <td>{{Spec2('WebGL2')}}</td>
   <td>Initial definition for WebGL.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 3.0', "glInvalidateSubFramebuffer.xhtml", "glInvalidateSubFramebuffer")}}</td>
   <td>{{Spec2('OpenGL ES 3.0')}}</td>
   <td>Man page of the (similar) OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGL2RenderingContext.invalidateSubFramebuffer")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGL2RenderingContext.invalidateFramebuffer()")}}</li>
</ul>
